/*
 * @(#)JugglerApplet.java	
 *
 * Copyright (c) 1996,7 Allen Knutson, Matthew Levine, Gregory Warrington
 * This file is part of [MA][GNU]S.
 * 
 * [MA][GNU]S is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * [MA][GNU]S is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with [MA][GNU]S; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.applet.*;
import java.io.*;
import java.awt.*;
import java.net.*;
import java.util.Vector;
import java.util.Enumeration;

/**
 * @author  Allen Knutson, Matthew Levine, Gregory Warrington
 * @version $Id: JugglerApplet.java,v 1.4 1997/03/16 19:36:17 gwar Exp $
 */

// This is strictly a wrapper for Juggler to make it run as an applet

public class JugglerApplet extends Applet
{
  Juggler juggler;

public JugglerApplet()  
  {
    juggler = new Juggler(this);
  }

public void init()
  {
    juggler.init();
  }
  
public void start()
  {
    juggler.start();
  }
  
public void stop()
  {
    juggler.stop();
  }

public void paint(Graphics g)
  {
  }

public String getAppletInfo()
  {
    return juggler.getAppletInfo();
  }

public String[][] getParameterInfo() 
  {
    return juggler.getParameterInfo();
  }    

public Image getImage(String s)
  {
    return getImage(getCodeBase(), s);
  }

public InputStream getText(String s)
  {
    URL u; 
    Object o;
    try {u = new URL(getCodeBase(), s); }
    catch (MalformedURLException e) { return null;}
    try {o=u.getContent();}
    catch (IOException e) {return null;}
    if ( o instanceof InputStream)
      return (InputStream)o;
    else return null;
  }

}
